#include<iostream>
using namespace std;

// this function compute the time of the given schedule
int computeTime(int n, int sequence[100], int s[100][100]);

int main() {
	// declare all the variables needed and get all the inputs
	int n = 0;
	cin >> n;
	int result = 0, p = 0;
	// Since the process time does not influence the result, I simply add it to the result here.
	// Get all the input.
	for(int i = 0; i < n; i++) {
		cin >> p;
		result += p;
	}
	int s[100][100] = {0};
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < n; j++) {
			cin >> s[i][j];
		}
	}
	
	// start from x0, compute the sum
	int tempChoice[100] = {0};
	for(int i = 0; i < n; i++) {
		tempChoice[i] = i;
	}
	int tempTime = computeTime(n, tempChoice, s);
	
	// check if the solution is local optimal
	bool localOptimal = false;
	while(!localOptimal) {
		localOptimal = true;
		int bestNeighbor[100] = {0};
		for(int i = 0; i < n; i++) {
			bestNeighbor[i] = tempChoice[i];
		}
		int bestNeighborTime = tempTime;
		int index1=0, index2=0;
		
		//check every neighbor and find the best
		for(int i = 0; i < n; i++) {
			for(int j = i+1; j < n; j++) {
				int tempNeighbor[100] = {0};
				for(int k = 0; k < n; k++) {
					tempNeighbor[k] = tempChoice[k];
				}
				tempNeighbor[i] = tempChoice[j];
				tempNeighbor[j] = tempChoice[i];
				int tempNeighborTime = computeTime(n, tempNeighbor, s);
				if((tempNeighborTime < bestNeighborTime) ||
				   ((tempNeighborTime == bestNeighborTime) && (tempNeighbor[i]+tempNeighbor[j] < index1+index2)) || 
				   ((tempNeighborTime == bestNeighborTime) && (tempNeighbor[i]+tempNeighbor[j] == index1+index2) && (tempNeighbor[i] < index1))) {
					bestNeighborTime = tempNeighborTime;
					for(int k = 0; k < n; k++) {
						bestNeighbor[k] = tempNeighbor[k];
					}
					localOptimal = false;
					if(tempNeighbor[i] < tempNeighbor[j]) {
						index1 = tempNeighbor[i];
						index2 = tempNeighbor[j];
					} else {
						index1 = tempNeighbor[j];
						index2 = tempNeighbor[i];
					}
					
				}
			}
		}
		// if the best neighbor is better than the current schedule, redo the procedure to this neighbor
		if(!localOptimal) {
			for(int i = 0; i < n; i++) {
				tempChoice[i] = bestNeighbor[i];
			}
			tempTime = bestNeighborTime;
		}
	}
	// output
	for(int i = 0; i < n; i++) {
		cout << tempChoice[i]+1 << " ";
	}
	result += tempTime;
	cout << result << "\n";
	
	return 0;
}
// this function compute the time of the given schedule
int computeTime(int n, int sequence[100], int s[100][100]) {
	int result = 0;
	for(int i = 0; i < n-1; i++) {
		result += s[sequence[i]][sequence[i+1]];
	}
	return result;
}
